diff -urN ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp ./src/sdl/debugger.cpp
--- ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp	2004-05-13 23:13:14 +0900
+++ ./src/sdl/debugger.cpp	2006-08-25 23:00:49 +0900
@@ -1397,7 +2096,450 @@
   }
 }
 
-void debuggerOutput(char *s, u32 addr)
+static void debuggerWriteState(int n, char **args)
+{
+  int num = 12;
+
+  if(n == 2) {
+    sscanf(args[1],"%d",&num);
+    if(num > 0 && num < 11)
+      sdlWriteState(num-1);
+    else
+      printf("Savestate number must be in the 1-10 range");
+  }
+  else
+    debuggerUsage("save");
+}
+
+static void debuggerReadState(int n, char **args)
+{
+  int num = 12;
+
+  if(n == 2) {
+    sscanf(args[1],"%d",&num);
+    if(num > 0 && num < 11)
+      sdlReadState(num-1);
+    else
+      printf("Savestate number must be in the 1-10 range");
+  }
+  else
+    debuggerUsage("load");
+}
+
+static void debuggerDumpLoad(int n, char** args)
+{
+  u32 address = 0;
+  char *file;
+  FILE *f;
+  int c;
+  
+  if(n==3) {
+    file=args[1];
+    
+    sscanf(args[2],"%x",&address);
+    
+    f=fopen(file,"rb");
+    if(!f) {
+      printf("Error opening file.\n");
+      return;
+    }
+    
+    fseek(f,0,SEEK_END);
+    int size=ftell(f);
+    fseek(f,0,SEEK_SET);
+    
+    for(int i=0;i<size;i++) {
+      c = fgetc(f);
+      if(c == -1)
+        break;
+      debuggerWriteByte(address,c);
+      address++;
+    }
+
+    fclose(f);
+  } else
+    debuggerUsage("dload");
+}
+
+static void debuggerDumpSave(int n, char** args)
+{
+  u32 address = 0;
+  u32 size = 0;
+  char *file;
+  FILE *f;
+  
+  if(n==4) {
+    file=args[1];
+    sscanf(args[2],"%x",&address);
+    sscanf(args[3],"%x",&size);
+    
+    f=fopen(file,"wb");
+    if(!f) {
+      printf("Error opening file.\n");
+      return;
+    }
+    
+    for(u32 i = 0; i < size; i++) {
+      fputc(debuggerReadByte(address), f);
+      address++;
+    }
+    
+    fclose(f);
+  } else
+    debuggerUsage("dsave");
+}
+
+static void debuggerCondBreakThumb(int n, char **args)
+{
+  if(n > 4) { //conditional args handled separately
+    int i = debuggerNumOfBreakpoints;
+    
+    u32 address = 0;
+    sscanf(args[1],"%x", &address);
+    
+    debuggerBreakpointList[i].address = address;
+    debuggerBreakpointList[i].value = debuggerReadHalfWord(address);
+    debuggerBreakpointList[i].size = 0;
+    
+    debuggerCondValidate(n, args,2);
+  } else
+    debuggerUsage("cbt");
+
+}
+
+static void debuggerCondBreakArm(int n, char **args)
+{
+  if(n > 4) { //conditional args handled separately
+    
+    int i = debuggerNumOfBreakpoints;
+    u32 address = 0;
+    
+    sscanf(args[1],"%x", &address);
+    debuggerBreakpointList[i].address = address;
+    debuggerBreakpointList[i].value = debuggerReadMemory(address);
+    debuggerBreakpointList[i].size = 1;
+    debuggerCondValidate(n, args,2);
+  } else
+    debuggerUsage("cba");
+}
+
+static void debuggerCondValidate(int n,char **args,int start)
+{
+  /*
+    0: address/register
+    1: op
+    2: value
+    3: size
+  */
+  
+  int i=debuggerNumOfBreakpoints;
+  
+  char *address=args[start];
+  char *op=args[start+1];
+  char *value=args[start+2];
+  char *tsize,*taddress,*tvalue;
+
+  int rel=0;
+  
+  u32 value1=0;
+  u32 value2=0;
+  
+  char size=0;
+  int j=1;
+  
+  if(n==6) {
+    size = args[start+3][0];
+    if(size != 'b' && size != 'h' && size != 'w') {
+      printf("Invalid size.\n");
+      return;
+    }
+    
+    switch(size) {
+    case 'b':
+      debuggerBreakpointList[i].cond_size=1;
+      tsize="byte";
+      break;
+    case 'h':
+      debuggerBreakpointList[i].cond_size=2;
+      tsize="halfword";
+      break;
+    case 'w':
+      debuggerBreakpointList[i].cond_size=4;
+      tsize="word";
+      break;
+    }
+  }
+
+  switch(toupper(address[0])) {
+  case '$': //is address
+    while (address[j]) {
+      address[j-1]=address[j];
+      j++;
+    }
+    address[j-1]=0;
+    
+    sscanf(address,"%x",&value1);
+    switch(size) {
+    case 'h':
+      if(value1 & 1) {
+        printf("Misaligned Conditional Address.\n");
+        return;
+      }
+      break;
+    case 'w':
+      if(value1 & 3) {
+        printf("Misaligned Conditional Address.\n");
+        return;
+      }
+    case 'b':
+      break;
+    default:
+      printf("Erroneous Condition\n");
+      debuggerUsage((char *)((toupper(args[0][2])=='T') ? "cbt" : "cba"));
+      return;
+    }
+    debuggerBreakpointList[i].ia1=true;
+    taddress="$";
+    break;
+  case 'R': //is register
+    while(address[j]) {
+      address[j-1]=address[j];
+      j++;
+    }
+    address[j-1]=0;
+    sscanf(address,"%d",&value1);
+    
+    if(value1 > 16) {
+      printf("Invalid Register.\n");
+      return;
+    }
+    if(size)
+      size=0;
+    debuggerBreakpointList[i].ia1=true;
+    taddress="r";
+    break;
+  default: //immediate;
+    printf("First Comparison Parameter should not be Immediate\n");
+    return;
+  }
+
+  debuggerBreakpointList[i].cond_address = value1;
+
+  // Check op 
+  switch(op[0]) {
+  case '=': // 1
+    if (op[1] == '=' && op[2]==0)
+      rel=1;
+    else 
+      goto error;
+    break;
+  case '!': //2
+    if (op[1]=='=' && op[2]==0)
+      rel=2;
+    else
+      goto error;
+    break;
+  case '<': //3
+    if(op[1]=='=')
+      rel=5;
+    else if (op[1]==0)
+      rel=3;
+    else
+      goto error;
+    break;
+  case '>': //4
+    if (op[1]=='=')
+      rel=6;
+    else if (op[1]==0)
+      rel=4;
+    else
+      goto error;
+    break;
+  default:
+  error:
+    printf("Invalid comparison operator.\n");
+    return;
+  }
+  
+  if(op==0) {
+    printf("Invalid comparison operator.\n");
+    return;
+  }
+  debuggerBreakpointList[i].cond_rel=rel;
+
+  switch(toupper(value[0])) {
+  case '$': //is address
+    while(value[j]) {
+      value[j-1]=value[j];
+      j++;
+    }
+    value[j-1]=0;
+
+    sscanf(value,"%x",&value2);
+    debuggerBreakpointList[i].ia2=true;
+    tvalue="$";
+    switch(size) {
+    case 'h':
+      if(value2 & 1) {
+        printf("Misaligned Conditional Address.\n");
+        return;
+      }
+      break;
+    case 'w':
+      if(value2 & 3) {
+        printf("Misaligned Conditional Address.\n");
+        return;
+      }
+    case 'b':
+      break;
+    default:
+      printf("Erroneous Condition\n");
+      debuggerUsage((char *)((toupper(args[0][2])=='T') ? "cbt" : "cba"));
+      return;
+    }
+    break;
+  case 'R': //is register
+    while(value[j]) {
+      value[j-1]=value[j];
+      j++;
+    }
+    value[j-1]=0;
+    sscanf(value,"%d",&value2);
+    
+    if(value2 > 16) {
+      printf("Invalid Register.\n");
+      return;
+    }
+    debuggerBreakpointList[i].ia2=true;
+    tvalue="r";
+    break;
+  default: //immediate;
+    sscanf(value, "%x",&value2);
+    debuggerBreakpointList[i].ia2=false;
+    tvalue="0x";
+    
+    switch(size) {
+    case 'b':
+      value2 &=0xFF;
+      break;
+    case 'h':
+      value2 &=0xFFFF;
+      break;
+    default:
+    case 'w':
+      value2 &=0xFFFFFFFF;
+      break;
+    }
+    break;
+  }
+  
+  debuggerBreakpointList[i].cond_value = value2;
+  debuggerNumOfBreakpoints++;
+  
+  // At here, everything's set. Display message.
+  switch(size) {
+  case 0:
+    printf("Added breakpoint on %08X if R%02d %s %08X\n",
+           debuggerBreakpointList[i].address,
+           debuggerBreakpointList[i].cond_address,
+           op,
+           debuggerBreakpointList[i].cond_value);
+    break;
+  case 'b':
+    printf("Added breakpoint on %08X if %s%08X %s %s%02X\n",
+           debuggerBreakpointList[i].address,
+           taddress,
+           debuggerBreakpointList[i].cond_address,
+           op,tvalue,
+           debuggerBreakpointList[i].cond_value);
+    break;
+  case 'h':
+    printf("Added breakpoint on %08X if %s%08X %s %s%04X\n",
+           debuggerBreakpointList[i].address,
+           taddress,
+           debuggerBreakpointList[i].cond_address,
+           op,
+           tvalue,
+           debuggerBreakpointList[i].cond_value);
+    break;
+  case 'w':
+    printf("Added breakpoint on %08X if %s%08X %s %s%08X\n",
+           debuggerBreakpointList[i].address,
+           taddress,
+           debuggerBreakpointList[i].cond_address,
+           op,tvalue,
+           debuggerBreakpointList[i].cond_value);
+    break;
+  }
+}
+
+static bool debuggerCondEvaluate(int num)
+{
+  // check if there is a condition
+  if(debuggerBreakpointList[num].cond_rel == 0)
+    return true;
+  
+  u32 address=debuggerBreakpointList[num].cond_address;
+  char size=debuggerBreakpointList[num].cond_size;
+  u32 value=debuggerBreakpointList[num].cond_value;
+  u32 value1=0;
+  u32 value2=0;
+  
+  if(address<17)
+    value1=reg[address].I;
+  else {
+    switch(size) {
+    case 1:
+      value1=debuggerReadByte(address);
+      break;
+    case 2:
+      value1=debuggerReadHalfWord(address);
+      break;
+    default:
+      value1=debuggerReadMemory(address);
+      break;
+    }
+  }
+	
+  //value2
+  if(debuggerBreakpointList[num].ia2) { //is address or register
+    if(value<17)
+      value2=reg[address].I;
+    else {
+      switch(size) {
+      case 'b':
+        value2=debuggerReadByte(value);
+        break;
+      case 'h':
+        value2=debuggerReadHalfWord(value);
+        break;
+      default:
+        value2=debuggerReadMemory(value);
+        break;
+      }
+    }
+  } else
+    value2=value;
+
+  switch(debuggerBreakpointList[num].cond_rel) {
+  case 1: // ==
+    return (value1 == value2);
+  case 2: // !=
+    return (value1 != value2);
+  case 3: // <
+    return (value1 < value2);
+  case 4: // >
+    return (value1 > value2);
+  case 5: // <=
+    return (value1 <= value2);
+  case 6: // >=
+    return (value1 >= value2);
+  default:
+    return false; //should never happen
+  }
+}
+
+/*extern*/ void debuggerOutput(char *s, u32 addr)
 {
   if(s)
     printf(s);
@@ -1414,7 +2556,65 @@
   }
 }
 
-void debuggerMain()
+char* strqtok (char* string, const char* ctrl)
+{ // quoted tokens
+  static char* nexttoken = NULL;
+  char* str;
+
+  if (string != NULL)
+    str = string;
+  else {
+    if (nexttoken == NULL)
+      return NULL;
+    str = nexttoken;
+  };
+
+  char deli [32];
+  memset (deli, 0, 32 * sizeof (char));
+  while (*ctrl)
+  {
+    deli [*ctrl >> 3] |= (1 << (*ctrl & 7));
+    ctrl++;
+  };
+  // can't allow to be set
+  deli ['"' >> 3] &= ~(1 << ('"' & 7));
+
+  // jump over leading delimiters
+  while ((deli [*str >> 3] & (1 << (*str & 7))) && *str)
+    str++;
+
+  if (*str == '"')
+  {
+    string = ++str;
+
+    // only break if another quote or end of string is found
+    while ((*str != '"') && *str)
+      str++;
+  } else {
+    string = str;
+
+    // break on delimiter
+    while (!(deli [*str >> 3] & (1 << (*str & 7))) && *str)
+      str++;
+  };
+
+  if (string == str)
+  {
+    nexttoken = NULL;
+    return NULL;
+  } else {
+    if (*str)
+    {
+      *str = 0;
+      nexttoken = str + 1;
+    } else
+      nexttoken = NULL;
+
+    return string;
+  };
+};
+
+/*extern*/ void debuggerMain()
 {
   char buffer[1024];
   char *commands[10];
@@ -1426,15 +2626,16 @@
   
   while(debugger) {
     systemSoundPause();
+    debuggerDisableBreakpoints();
     printf("debugger> ");
     commandCount = 0;
     char *s = fgets(buffer, 1024, stdin);
 
-    commands[0] = strtok(s, " \t\n");
+    commands[0] = strqtok(s, " \t\n");
     if(commands[0] == NULL)
       continue;
     commandCount++;
-    while((s = strtok(NULL, " \t\n"))) {
+    while((s = strqtok(NULL, " \t\n"))) {
       commands[commandCount++] = s;
       if(commandCount == 10)
         break;
@@ -1452,3 +2653,12 @@
     } 
   }
 }
+
+void debuggerLast(int n, char **args)
+{
+debugger_last =!debugger_last;
+if (debugger_last == true)
+printf ("Last registers will be shown\n");
+else
+printf ("Last registers wont be shown\n");
+}
